"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolvePlugins = resolvePlugins;
exports.applyPlugins = applyPlugins;

var _fs = require("fs");

var _assert = _interopRequireDefault(require("assert"));

function resolvePlugin(plugin) {
  (0, _assert.default)((0, _fs.existsSync)(plugin), "plugin file not exists: ".concat(plugin));
  return require(plugin);
}

function resolvePlugins() {
  var plugins = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return plugins.map(resolvePlugin);
}

function applyPlugins(plugins, method, initialValue, pluginArg) {
  return plugins.reduce(function (memo, plugin) {
    if (plugin[method]) {
      return plugin[method](memo, pluginArg);
    } else {
      return memo;
    }
  }, initialValue);
}